;**************************************
; :                          *
; :     17/3/2010                 *
; :    1,0                      *
;  :                          *
;  AVR:     ATtiny                 *
;  :    8 MHz          *
;**************************************

;  :  
;                       
;                       B
;                     PB4-PB7 4- 
;                               PB1-RS
;                               PB2-RW
;                               PB3-E
;                  

.device           ATtiny2313
.list
.include         "tn2313def.inc"
.list
.include         "subroutines.asm"
; ==================
; :

.cseg
.org	0


.def      temp=   r16
.def      lcd=    r17
.def      temp2=  r18
.def      temp3=  r19
.def      cur=    r20 
.equ RW          =PB2
.equ RS          =PB1
.equ E           =PB3
.equ menu        =PD0
.equ left        =PD1
.equ right       =PD2
.equ enter       =PD3
;===================
;   

rjmp   init


;====================

Init:
;    
        ldi    temp,0b11110000  ; PD0-PD3-
		out     DDRD,temp       ; - .
		ser     temp
		out     PORTD,temp      ;     					
		clr     temp        	;  		
		ldi		temp,0b11111110	; (  )
		out		DDRB,temp
        out		PORTB,temp	    ;    0   
							    ;     
							    ; 
  
 
     
 
;  
 ldi temp, LOW(RAMEND)
 out SPL, temp

 

;  
  ldi     temp2,4
  ldi     temp,10                 ; 
  rcall   Delay15                 ; 
  dec     temp                    ; 15 
  brne    PC-2
  ldi     lcd,0x30                ;   0x30-
  rcall   lcd_com                 ;  8- 
  ldi     temp,4
  rcall   Delay15                 ; 
  dec     temp                    ;  6
  brne    pc-2 
  dec     temp2                               
  ldi     lcd,0x30                ;   0x30-
  rcall   lcd_com                 ;  8- 
  ldi     temp,3
  rcall   Delay40                 ; 
  dec     temp                    ; 
  brne    pc-2                    ; 120 
  dec     temp2
  ldi     lcd,0x30                ;   0x30-
  rcall   lcd_com                 ;  8- 
  dec     temp2
  
  ldi     lcd,0x20                ;   0x20
  rcall   lcd_com                 ;  4- 
  dec    temp2
  
  ldi     lcd,0x28               ;   0x28
  rcall   lcd_com                 
  
  ldi     lcd,0x0C               ;   0x0C
  rcall   lcd_com                 
  
  ldi     lcd,0x06               ;   0x06
  rcall   lcd_com
  rcall   clscr
  
 
  
;=====================

;   

Start:
   
 
 ;   " :"
        ldi    lcd,0x80             ;  
		rcall  lcd_com              ;   1 
        ldi    temp3,15              ; temp3-  
        ldi		zl,low(mess7*2)		;  Z 
        ldi		zh,high(mess7*2)	;    mess7
		rcall   output

 ;   "   >"
 Menu1:  ldi    lcd,0xC0             ;  
		rcall   lcd_com              ;   2 
		ldi     lcd,$20               ;  
		rcall   lcd_data              ; ,
		rcall   lcd_data              ;  
		rcall   lcd_data
        ldi     temp3,8              ; temp3-  
        ldi		zl,low(mess6*2)		;  Z 
        ldi		zh,high(mess6*2)	;    mess6
		rcall   output		
        ldi     cur,4               ;   
        rcall   r_shift             ;  4 
		ldi     lcd,0x3E            ;   >
		rcall   lcd_data 
		 
;  		     
scan1:  in    temp, PIND
        andi  temp,0b00001111
		cpi   temp,0b00000111       ;  "" ?
		breq  TestAKB               ;    "  "
		cpi   temp,0b00001011       ;  > ?
		breq  menu2                 ;   2
		;rcall delay15
		rjmp  scan1

 ;   "<  >" 
 Menu2: ldi    lcd,0xC0             ;   
		rcall  lcd_com              ;   2 
        ldi    temp3,16              ; temp3-  
        ldi		zl,low(mess8*2)		;  Z 
        ldi		zh,high(mess8*2)	;    mess8
		rcall   output

;  
    	 in    temp,PIND            ;   
		 andi  temp,0b00001111
		 cpi   temp,0b00001111
		 brne  pc-3
 scan2:  in    temp, PIND
         andi  temp,0b00001111
		 cpi   temp,0b00000111       ;  "" ?
		 breq  Zar                   ;    ""
		 cpi   temp,0b00001011       ;  > ?
		 breq  menu3                 ;   3
		 cpi   temp,0b00001101       ;  < ?
		 breq  menu1
		;rcall delay15
		 rjmp  scan2

 ;   "  "
 TestAKB: rcall  clscr
          ldi    lcd,0x84             ;  
		  rcall  lcd_com              ;   1 
          ldi    temp3,8              ; temp3-  
          ldi		zl,low(mess6*2)		;  Z 
          ldi		zh,high(mess6*2)	;    mess6
		  rcall   output

 ;   "...15
        ldi   lcd,0xC0               ;    
		rcall  lcd_com               ;     
        ldi    temp3,16              ; temp3-  
        ldi		zl,low(mess2*2)		 ;  Z 
        ldi		zh,high(mess2*2)	 ;    mess2
		rcall   output
  ;    
       
        ldi     cur,4                ;   
	    rcall   l_shift              ; 4  	          
        ldi     temp3,5             ; temp3-  
        ldi	   zl,low(mess4*2)		;  Z 
        ldi     zh,high(mess4*2)	     ;    mess4
	    add     temp3,zl
  m3:   lpm
        rcall    delay1
	    mov     lcd,r0
		rcall   lcd_data
		adiw    z,1
        ldi     cur,1
	    rcall   l_shift
		cp      zl,temp3
		brne	m3
        ldi     cur,1                ;   
	    rcall   l_shift              ; 1  
		rcall   delay1
	    ldi    lcd,$30
		rcall   lcd_data
		ldi     lcd,$39
		rcall   lcd_data
        ldi     temp3,9            ; temp3-  
        ldi	   zl,low(mess5*2)	   	;  Z 
        ldi     zh,high(mess5*2)   ;    mess4
	    add     temp3,zl
  m5:   lpm
        ldi     cur,1                ;   
	    rcall   l_shift              ; 1  
        rcall   delay1
	    mov     lcd,r0
		rcall   lcd_data
		adiw    z,1
		cp      zl,temp3
		brne	m5    
		    
;  "<  "
Menu3:  ldi    lcd,0xC0             ;   
		rcall  lcd_com              ;   2 
        ldi    temp3,16              ; temp3-  
        ldi		zl,low(mess9*2)		;  Z 
        ldi		zh,high(mess9*2)	;    mess8
		rcall   output 

;  
   	     in    temp,PIND            ;   
		 andi  temp,0b00001111
		 cpi   temp,0b00001111
		 brne  pc-3
         in temp,PIND
         ;andi  temp,0b00001111
		 ;cpi   temp,0b00000111       ;  "" ?
		 ;breq  Tren                  ;    ""
		 ;cpi   temp,0b00001101       ;  < ?
		; breq  menu2
		;rcall delay15
		 ;rjmp  scan3

   ;   "="
        
		;ldi   lcd,0xC0              ;    
		;rcall  lcd_com              ;    
		;ldi    temp3,11                ; temp2-  
        ;ldi		zl,low(mess1*2)		;  Z 
        ;ldi		zh,high(mess1*2)	;    mess3
		;add   temp3,zl
 ; m1    lpm
		;mov  lcd,r0
		;rcall  lcd_data
		;adiw  z,1
        
		;cp  zl,temp3
		;brne	m1

   

stop:
zar:   ;    ""   
tren:  ;    " "
    	
        rjmp    stop
		
 rjmp   init       
           ; 

mess1:		
.db	$48, $61, $BE, $70, $C7, $B6, $65, $BD, $B8, $65, $3D ,0; =
mess2:
.db $A8, $6F, $E3, $6F, $B6, $E3, $B8, $BF, $65, $2E, $2E, $31, $35, $63, $65, $BA ; ..15     
mess4:
.db $34, $33, $32, $31, $30, 0 ; 43210
mess5:
.db $38, $37, $36, $35, $34, $33, $32, $31, $30, 0 ; 876543210
mess6:
.db $54, $65, $63, $BF, $20, $41, $4B, $A0 ;  
mess7:
.db $42, $C3, $B2, $65, $70, $B8, $BF, $65, $20, $70, $65, $B6, $B8, $BC, $3A, 0; 
mess8:
.db $3C, $20, $20, $20, $20, $20, $A4, $61, $70, $C7, $E3, $20, $20, $20, $20, $3E ;<  >
mess9:
.db $3C, $20, $20, $20, $54, $70, $65, $BD, $B8, $70, $6F, $B3, $BA, $61, $20, $20 ; < 



